/* Kvaser Linux Canlib
 * Read timer test
 * Copyright (C) 2003 Kvaser AB - support@kvaser.com - www.kvaser.com
 */

/* This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 */

#include <stdio.h>
#include <canlib.h>
#include <unistd.h>
#include <sys/time.h>

int main(int argc, char *argv[])
{
  unsigned long time, last=0, lastsys=0;
  char errorString[50];
  canHandle h;
  struct timeval tv;
  
  h = canOpenChannel(1, 0);
  if (h < 0) {
    canGetErrorText(h, errorString, 50);
    printf("%s\n", errorString);
  } 
  while(1){
    if (canReadTimer(h, &time) == canOK) printf("Time=%ld ms (%ld)\n", time, time-last);
    else break;
    gettimeofday(&tv, NULL);
    printf("system:%ld\n", tv.tv_sec * 1000 + tv.tv_usec / 1000 - lastsys);
    last = time;
    lastsys = tv.tv_sec * 1000 + tv.tv_usec / 1000;
    sleep(1);
  }
  printf("canReadTimer failed\n");
  canClose(h);
  return 0;
}
