#!/bin/sh

# Kvaser CAN driver                     
# pcican.sh - start/stop pcican and create/delete inodes  
# Copyright (C) 2003 Kvaser AB - support@kvaser.com - www.kvaser.com  
 
case "$1" in
    start)
         insmod kvpcican || exit 1
	 nrchan=`cat /proc/pcican | grep 'total channels' | awk '{print $3}'`
	 major=`cat /proc/devices | grep 'pcican' | awk '{print $1}'`
	 
	 rm -f /dev/pcican*
	 for (( minor=0 ; minor<$nrchan; minor++ )) ; do 
	     mknod /dev/pcican$minor c $major $minor
	 done
	 ;;
    stop)
         rmmod kvpcican || exit 1
	 rm -f /dev/pcican*
	 ;;
    *)
         printf "Usage: %s {start|stop}\n" $0
esac

exit 0