/* Kvaser Linux Canlib
 * Test set bus parameters
 * Copyright (C) 2003 Kvaser AB - support@kvaser.com - www.kvaser.com
 */

/* This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 */

#include <canlib.h>
#include <stdio.h>

void check(char* id, canStatus stat)
{
    char buf[50];

    buf[0] = '\0';
    canGetErrorText(stat, buf, sizeof(buf));
    if (stat != canOK) printf("%s: failed, stat=%d (%s)\n", id, (int)stat, buf);
    else printf("%s: OK\n", id);
    return;
}


/* Set bus parameters and read them back 10000 times */

int main (int argc, char *argv[])

{
    long freq;
    int tseg1, tseg2, sjw, noSamp, syncmode;
    int ret = -1;
    int i, j;
    canHandle h;
  
    h = canOpenChannel(j, canWANT_EXCLUSIVE | canWANT_EXTENDED);
    if (h < 0) {
	printf("canOpenChannel (%d) failed\n", j);
	return -1;
    }
    ret = canSetBusParams(h, BAUD_500K, 4, 3, 1, 1, 0);
    check("canSetBusParams", ret);
    ret = canBusOn(h);
    check("canBusOn", ret);

    canBusOff(h);
    canClose(h);


    return 0;
}



